/* Install for the WPTOOLS */

call RxFuncAdd "SysLoadFuncs", "REXXUTIL", "SysLoadFuncs"
call SysLoadFuncs

CALL SysCls

say 'Rexx Installer for the WPTOOLS'
say '--------------------------------------------'
say
say '   Installation...'
say
say '   creates folder and objects on desktop'
say '   nothing else'
say '   Please read the supplied information file for correct operation'
say

/* Ask Directory */

say '(<return> = current directory, object creation only, no copy operation)'
PARSE PULL InstDir
InstDir = STRIP(InstDir, 'T', '\')

IF InstDir="" THEN
 DO
   InstDir=directory()
   SIGNAL MakeIcons
 END

/* Create Directory */
say
say '--------------------------------------------'
say 'creating directories'
say '--------------------------------------------'

if InstDir <> "." then
   DO
     call SysFileTree InstDir, "SearchDir", "D"
     if SearchDir.0 = 0 then do
         rc = SysMkDir(InstDir)
            if rc <> 0 then do
                 say "Error: Cannot create directory!" InstDir
                 exit
            end
     end
end


MakeIcons:

/* Make icons */
say
say '--------------------------------------------'
say 'creating icons'
say '--------------------------------------------'


classname = 'WPFolder'
title     = 'WPTOOLS'
location  = '<WP_DESKTOP>'
icon1     = InstDir||'\WPTOOL1.ICO'
icon2     = InstDir||'\WPTOOL2.ICO'
icon      = 'ICONFILE='icon1||';ICONNFILE=1,'||icon2
folderid  = '<WPTOOLS_FOLDER>'
setup     = 'OBJECTID='||folderid||';'||icon
rc        = SysCreateObject(classname, title, location ,setup,'U')

classname = 'WPProgram'
location  = '<WPTOOLS_FOLDER>'
title     = 'Checkini'
exename   = 'EXENAME='||InstDir||'\checkini.EXE'
WorkDir   = InstDir
setup     = 'OBJECTID=<checkini_PROGRAM>;STARTUPDIR='||InstDir||';STARTUPDIR='||Workdir||';'||exename
rc        = SysCreateObject(classname, title, folderid, setup, 'U')          

classname = 'WPProgram'
location  = '<WPTOOLS_FOLDER>'
title     = 'Resetwps'
exename   = 'EXENAME='||InstDir||'\Resetwps.EXE'
WorkDir   = InstDir
setup     = 'OBJECTID=<Resetwps_PROGRAM>;STARTUPDIR='||InstDir||';STARTUPDIR='||Workdir||';'||exename
rc        = SysCreateObject(classname, title, folderid, setup, 'U')          

classname = 'WPProgram'
location  = '<WPTOOLS_FOLDER>'
title     = 'Wpsrestore'
exename   = 'EXENAME='||InstDir||'\Wpsrest.EXE'
WorkDir   = InstDir
setup     = 'OBJECTID=<Wpsrestore_PROGRAM>;STARTUPDIR='||InstDir||';STARTUPDIR='||Workdir||';'||exename
rc        = SysCreateObject(classname, title, folderid, setup, 'U')          

classname = 'WPProgram'
location  = '<WPTOOLS_FOLDER>'
title     = 'Wpsbackup'
exename   = 'EXENAME='||InstDir||'\Wpsbkp.EXE'
WorkDir   = InstDir
setup     = 'OBJECTID=<Wpsbackup_PROGRAM>;STARTUPDIR='||InstDir||';STARTUPDIR='||Workdir||';'||exename
rc        = SysCreateObject(classname, title, folderid, setup, 'U')          

classname = 'WPProgram'
location  = '<WPTOOLS_FOLDER>'
title     = 'Getobj'
exename   = 'EXENAME='||InstDir||'\Getobj.EXE'
WorkDir   = InstDir
setup     = 'OBJECTID=<Getobj_PROGRAM>;STARTUPDIR='||InstDir||';STARTUPDIR='||Workdir||';'||exename
rc        = SysCreateObject(classname, title, folderid, setup, 'U')          

classname = 'WPProgram'
location  = '<WPTOOLS_FOLDER>'
title     = 'Defassoc'
exename   = 'EXENAME='||InstDir||'\Defassoc.EXE'
WorkDir   = InstDir
setup     = 'OBJECTID=<Defassoc_PROGRAM>;STARTUPDIR='||InstDir||';STARTUPDIR='||Workdir||';'||exename
rc        = SysCreateObject(classname, title, folderid, setup, 'U')          

exit
